﻿import mx.controls.Alert;

function doSocketConnect(evt) {
	if (evt.detail == 1) {
		retries=3;
		stream.connect(host, port);
	}
}

function XMLSconnect (ok) {
	trace("connection status="+ok+"\r");
	if (!ok) {
		if (--retries > 0) {
			stream.connect(host, port);
		}
		else {
			Alert.show("Konnte keine Socketverbindung mit "+host+" herstellen. Nochmal versuchen?",
					   1|2, null, doSocketConnect);
			trace("keine verbindung..");
		}
	} else {
		stream.onXML = getSocketData;
		ready_state++;
	}
}
function parseSocketNode(node) {
	var out=new Object();
	if (node.firstChild.nodeType==3) {
		out=node.firstChild.nodeValue;
	}
	if (node.attributes) {
		var atr=node.attributes;
		for (var zz in atr) {
			if (!isNaN(atr[zz])) {
				out[zz]=Number(atr[zz]);
			}
			else {
				out[zz]=atr[zz];
			}
		}
	}
	if (node.hasChildNodes()) {
		for (var child=node.firstChild; child!=null; child=child.nextSibling) {
			if (child.nodeName!=null) {
				out[child.nodeName]=parseSocketNode(child);
			}
		}
	}
	if (out!=undefined) return out;
}

function getSocketData(obj) {
	var dat=parseSocketNode(obj.firstChild);
	var c=0;
	for (z in dat) {
		_root.joysticks[dat[z].num]=dat[z];
	}
}

host='localhost';
port=5204;

stream = new XMLSocket();
stream.onConnect = XMLSconnect;
stream.connect(host, port);